-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local LJDCastingBarFrame = CreateFrame("FRAME");
LJDCastingBarFrame:SetScript('OnEvent', function(self, event, ...)
    return self:Events(event, ...);
end)


LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_SENT");

LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_DELAYED");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_START");

LJDCastingBarFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
LJDCastingBarFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
LJDCastingBarFrame:RegisterEvent("PLAYER_ENTERING_WORLD");

function LJDCastingBarFrame:Events(...)
    local ll = {...};
    local event = ll[1];
    --DebugPrint(event);
    --DebugPrint(self);
    --DebugPrintTable(self);
    
    if( event == "PLAYER_ENTERING_WORLD" ) then
        self:PLAYER_ENTERING_WORLD();
    elseif( event == "PLAYER_TARGET_CHANGED" ) then
        self:PLAYER_TARGET_CHANGED(unpack(ll));
    elseif( event == "UPDATE_MOUSEOVER_UNIT" ) then
        self:UPDATE_MOUSEOVER_CHANGED(unpack(ll));
    else
        local unitId = ll[2];
        local startSpellId = ll[4];

        LJDShowCastingBar(unitId, startSpellId);
        LJDShowCastingSpellToolip(unitId, startSpellId);
    end
end

function LJDCastingBarFrame:PLAYER_ENTERING_WORLD()

    -- 캐스트바 프레임 생성(target 전용)
    local castBar = _G["LJDCastingBar"];
    if( not castBar ) then

        castBar = CreateFrame("Frame", "LJDCastingBar", UIParent, BackdropTemplateMixin and "BackdropTemplate");
        castBar:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=2});
        castBar:SetBackdropBorderColor(0,0,0,0.4)
        
        castBar:SetPoint("TOP", UIParent, "TOP", 0, -30);
        
        castBar:SetMovable(true);
        castBar:EnableMouse(true);
        castBar:RegisterForDrag("LeftButton");
        castBar:SetScript("OnDragStart", castBar.StartMoving);
        castBar:SetScript("OnDragStop", castBar.StopMovingOrSizing);
        castBar:SetSize(800,32);

        castBar.progressBar = CreateFrame("StatusBar", nil, castBar, "CastingBarFrameTemplate");
        castBar:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        castBar:SetFrameLevel(101);      -- 퀘스트 위에 보일려고
        --castBar.progressBar:SetScript("OnShow", function(self) self:GetParent():Show(); end);
        castBar.progressBar:SetScript("OnHide", function(self) self:GetParent():Hide(); end);
        --castBar.progressBar:SetAllPoints();
        castBar.progressBar:SetPoint("TOPLEFT", castBar ,"TOPLEFT", 2, -2);
        castBar.progressBar:SetPoint("BOTTOMRIGHT", castBar ,"BOTTOMRIGHT", -2, 2);

        --castBar.progressBar.Border:SetSize(254,64);
        --castBar.progressBar.BorderShield:SetSize(254,64);
        
        castBar.progressBar.Text:ClearAllPoints();
        castBar.progressBar.Text:SetAllPoints();
        castBar.progressBar.Text:SetPoint("CENTER", 0, 0);
        castBar.progressBar.Text:SetFont(STANDARD_TEXT_FONT, 16, "OUTLINE");
        --castBar.progressBar.Text:SetTextHeight(20);
        
        --castBar.progressBar.Text:SetSize(185,16);
        castBar.progressBar.Icon:SetSize(32,32);
        
        castBar.progressBar.Spark:SetSize(32,32);
        castBar.progressBar.Flash:ClearAllPoints();
        --castBar.progressBar.Flash:SetAllPoints();
        castBar.progressBar.Flash:SetPoint("CENTER", 0, 0);
        castBar.progressBar.Flash:SetSize(1000,64);
        castBar.progressBar.Border:Hide();

        CastingBarFrame_OnLoad(castBar.progressBar, nil, true, false);
        castBar:Hide();
    end

    -- 캐스트바 프레임 생성(MouseOver 전용툴팁)
    local castBarMO = _G["LJDCastingBarMO"];
    if( not castBarMO ) then

        castBarMO = CreateFrame("Frame", "LJDCastingBarMO", UIParent, BackdropTemplateMixin and "BackdropTemplate");
        castBarMO:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=2});
        castBarMO:SetBackdropBorderColor(0,0,0,0.4)
        
        castBarMO:SetPoint("TOP", UIParent, "TOP", 0, -30);
        
        castBarMO:SetMovable(true);
        castBarMO:EnableMouse(true);
        castBarMO:RegisterForDrag("LeftButton");
        castBarMO:SetScript("OnDragStart", castBarMO.StartMoving);
        castBarMO:SetScript("OnDragStop", castBarMO.StopMovingOrSizing);
        castBarMO:SetSize(800,32);

        castBarMO.progressBar = CreateFrame("StatusBar", nil, castBarMO, "CastingBarFrameTemplate");
        castBarMO:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        castBarMO:SetFrameLevel(101);      -- 퀘스트 위에 보일려고
        --castBarMO.progressBar:SetScript("OnShow", function(self) self:GetParent():Show(); end);
        castBarMO.progressBar:SetScript("OnHide", function(self) self:GetParent():Hide(); end);
        --castBarMO.progressBar:SetAllPoints();
        castBarMO.progressBar:SetPoint("TOPLEFT", castBarMO ,"TOPLEFT", 2, -2);
        castBarMO.progressBar:SetPoint("BOTTOMRIGHT", castBarMO ,"BOTTOMRIGHT", -2, 2);

        --castBarMO.progressBar.Border:SetSize(254,64);
        --castBarMO.progressBar.BorderShield:SetSize(254,64);
        
        castBarMO.progressBar.Text:ClearAllPoints();
        castBarMO.progressBar.Text:SetAllPoints();
        castBarMO.progressBar.Text:SetPoint("CENTER", 0, 0);
        castBarMO.progressBar.Text:SetFont(STANDARD_TEXT_FONT, 16, "OUTLINE");
        --castBarMO.progressBar.Text:SetTextHeight(20);
        
        --castBarMO.progressBar.Text:SetSize(185,16);
        castBarMO.progressBar.Icon:SetSize(32,32);
        
        castBarMO.progressBar.Spark:SetSize(32,32);
        castBarMO.progressBar.Flash:ClearAllPoints();
        --castBarMO.progressBar.Flash:SetAllPoints();
        castBarMO.progressBar.Flash:SetPoint("CENTER", 0, 0);
        castBarMO.progressBar.Flash:SetSize(1000,64);
        castBarMO.progressBar.Border:Hide();

        CastingBarFrame_OnLoad(castBarMO.progressBar, nil, true, false);
        castBarMO:Hide();
    end

    -- 툴팁 프레임 생성(target 전용)
    local tooltip = _G["LJDCastingToolip"];
    if( not tooltip ) then
        tooltip = CreateFrame("GameTooltip", "LJDCastingToolip", UIParent, "GameTooltipTemplate");
        tooltip:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        tooltip:SetFrameLevel(100);      -- 퀘스트 위에 보일려고
        tooltip:SetMovable(true);
        tooltip:EnableMouse(true);
        tooltip:RegisterForDrag("LeftButton");
        tooltip:SetScript("OnDragStart", tooltip.StartMoving);
        tooltip:SetScript("OnDragStop", tooltip.StopMovingOrSizing);
        
        -- 닫기버튼 추가
        tooltip.closeBtn = CreateFrame("Button", "$parentCloseButton", tooltip);
        tooltip.closeBtn:SetSize(32,32);
        tooltip.closeBtn:SetPoint("TOPRIGHT",1,0);
        tooltip.closeBtn:SetNormalTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Up]]);
        tooltip.closeBtn:SetPushedTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Down]]);
        tooltip.closeBtn:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]]);
        tooltip.closeBtn:SetScript("OnClick", function(self)
            tooltip:Hide();
        end);

        tooltip:SetOwner(TargetFrameSpellBar, "ANCHOR_BOTTOMRIGHT");    -- 초기위치 설정(타켓캐스팅 옆)
        
        local castBar = _G["LJDCastingBar"];
        if(castBar) then
            -- 초기위치 재설정(LJD캐스트바 옆)
            tooltip:ClearAllPoints();
            tooltip:SetPoint("TOPLEFT", castBar ,"TOPRIGHT", 0, 0);
        end
    end

    -- 툴팁 프레임 생성(MouseOver 전용툴팁)
    local tooltipMO = _G["LJDCastingToolipMO"];
    if( not tooltipMO ) then
        tooltipMO = CreateFrame("GameTooltip", "LJDCastingToolipMO", UIParent, "GameTooltipTemplate");
        tooltipMO:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        tooltipMO:SetFrameLevel(100);      -- 퀘스트 위에 보일려고
        tooltipMO:SetMovable(true);
        tooltipMO:EnableMouse(true);
        tooltipMO:RegisterForDrag("LeftButton");
        tooltipMO:SetScript("OnDragStart", tooltipMO.StartMoving);
        tooltipMO:SetScript("OnDragStop", tooltipMO.StopMovingOrSizing);
        
        -- 닫기버튼 추가
        tooltipMO.closeBtn = CreateFrame("Button", "$parentCloseButton", tooltipMO);
        tooltipMO.closeBtn:SetSize(32,32);
        tooltipMO.closeBtn:SetPoint("TOPRIGHT",1,0);
        tooltipMO.closeBtn:SetNormalTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Up]]);
        tooltipMO.closeBtn:SetPushedTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Down]]);
        tooltipMO.closeBtn:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]]);
        tooltipMO.closeBtn:SetScript("OnClick", function(self)
            tooltipMO:Hide();
        end);

        --tooltipMO:SetOwner(TargetFrameSpellBar, "ANCHOR_BOTTOMRIGHT");    -- 초기위치 설정(타켓캐스팅 옆)
        
        local castBar = _G["LJDCastingBar"];
        if(castBar) then
            -- 초기위치 재설정(LJD캐스트바 왼쪽옆)
            tooltipMO:ClearAllPoints();
            tooltipMO:SetPoint("TOPRIGHT", castBar ,"TOPLEFT", -35, 0);
        end
    end

    -- 타이머
    LJDCastingBarFrame:StartTimer();
    
end

-- Player 의 대상 변경시 캐스팅
function LJDCastingBarFrame:PLAYER_TARGET_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);
    --local unitId = "target";
    --local startSpellId = nil;

    LJDShowCastingBar();
    LJDShowCastingSpellToolip();
end

-- Player 의 마우스오버 변경시
function LJDCastingBarFrame:UPDATE_MOUSEOVER_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);
    --local unitId = "mouseover";
    --local startSpellId = nil;

    LJDShowCastingBar();
    -- 가장 최근 사용한 스킬 툴팁을 보여준다.
    LJDShowCastingSpellToolip();
end


-- 캐스팅바를 숨긴다.
--[[
function LJDHideCastingBar()
    local castBar = _G["LJDCastingBar"];
    if( castBar ) then
        castBar:Hide();
    end
    
    castBar = _G["LJDCastingBarMO"];
    if( castBar ) then
        castBar:Hide();
    end
    
end
--]]

-- OnUpdate 이벤트 대체용 타이머
function LJDCastingBarFrame:StartTimer()
    -------------------------------------------------------------------------
    -- 진득주 1)
    -- NewTicker 와 NewTimer에 관하여 .. 
    -- NewTicker는 세번째 인자 : 반복수(iterations)가 1인(한번) 
    -- NewTimer와 같다.
    -- (NewTicker의 기본값은 무한반복)
    -------------------------------------------------------------------------
    -- 진득주 2)
    -- Duration 이 0.001(1ms) 이하이면, 게임 클라이언트에 영향을 줄수 있다.
    -- 적어도, 60 FPS를 지켜 보려면, 60 FPS 가 0.016 s(f=1/t) 이므로, 
    -- 대강 0.01 보단 높게 설정하게 한다.
    -- 아래 math.max 가 그 역할용으로 최소값을 지정했다. 
    -------------------------------------------------------------------------
	if not LJDCastingBarFrame.ticker then
		LJDCastingBarFrame.ticker = C_Timer.NewTicker(0.2, function() LJDCastingBarFrame:onUpdate() end );   -- 60 프레임 지켜보려고..
	end
end

function LJDCastingBarFrame:StopTimer()
	if LJDCastingBarFrame.ticker then
		LJDCastingBarFrame.ticker:Cancel();
		LJDCastingBarFrame.ticker = nil;
	end
end

-- UPDATE_MOUSEOVER_UNIT + lost 이벤트 구현(UPDATE_MOUSEOVER_CHANGED)
function LJDCastingBarFrame:onUpdate()

    ------------------------------------------------------------------------------
    -- UPDATE_MOUSEOVER_UNIT 이벤트는 유닛이 lost 된 경우 발생하지 않는다.
    -- 이를 보완하기 위해(lost 된 경우만) 추가 호출함.
    ------------------------------------------------------------------------------
    local unitId = "mouseover";
    local existsMouseOverUnit = UnitExists(unitId);

    if( LJDExistsMouseOverUnit ~= existsMouseOverUnit ) then
        LJDExistsMouseOverUnit = existsMouseOverUnit;
        
        if( not existsMouseOverUnit ) then
            LJDCastingBarFrame.UPDATE_MOUSEOVER_CHANGED(self, "UPDATE_MOUSEOVER_UNIT");
        end
    end

    
    --LJDShowCastingBar(nil);
    --LJDShowCastingSpellToolip(nil);

end

-- 캐스팅바를 보여준다.
function LJDShowCastingBar(unitId, spellId)

    LJDShowCastingBarTarget(unitId or "target");
    LJDShowCastingBarMO(unitId or "mouseover");
    
end

-- 캐스팅바를 보여준다.(대상 전용)
function LJDShowCastingBarTarget(unitId, spellId)
    --DebugPrint(unitId);
    --if( unitId ~= "target" and not UnitIsUnit(unitId, "mouseover") ) then

    if( not UnitIsUnit(unitId, "target") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅바 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingBar"] ) then
        return;
    end

    -- 즉시 시전 스킬인 경우(UNIT_SPELLCAST_SUCCEEDED 이벤트)를 감안하여
    -- 스킬정보를 매번 다시 확인한다.
    spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
    --DebugPrint(spellId);

    local castBar = _G["LJDCastingBar"];
    if( castBar ) then
        if( not spellId ) then
            castBar:Hide();
            return;
        end
        
        CastingBarFrame_SetUnit(castBar.progressBar, unitId, true, false);
        castBar:Show();
    end
    
    if( UnitExists("mouseover") ) then
        -- 숨김
        castBar:Hide();
    end
    
    --DebugPrint(castBar:GetName() .. ":" .. castBar.progressBar.unit );

end


-- 캐스팅바를 보여준다.(마우스오버 전용)
function LJDShowCastingBarMO(unitId, spellId)
    --DebugPrint(unitId);
    --if( unitId ~= "target" and not UnitIsUnit(unitId, "mouseover") ) then

    if( not UnitIsUnit(unitId, "mouseover") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅바 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingBar"] ) then
        return;
    end

    -- 즉시 시전 스킬인 경우(UNIT_SPELLCAST_SUCCEEDED 이벤트)를 감안하여
    -- 스킬정보를 매번 다시 확인한다.
    spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
    --DebugPrint(spellId);

    local castBar = _G["LJDCastingBarMO"];
    if( castBar ) then
        if( not spellId ) then
            castBar:Hide();
            return;
        end
    
        CastingBarFrame_SetUnit(castBar.progressBar, unitId, true, false);
        castBar:Show();
    end

    --DebugPrint(castBar:GetName() .. ":" .. castBar.progressBar.unit );

end


-- 가장 최근 사용한 스킬 툴팁을 보여준다.
function LJDShowCastingSpellToolip(unitId, startSpellId)

    -- 툴팁은 대상은 오른쪽, 마우스오버는 왼쪽에 동시에 표현된다.
    LJDShowCastingSpellToolipTarget(unitId or "target", startSpellId);  -- 대상
    LJDShowCastingSpellToolipMO(unitId or "mouseover", startSpellId);   -- 마우스오버

end

-- 가장 최근 사용한 스킬 툴팁을 보여준다.(대상용)
function LJDShowCastingSpellToolipTarget(unitId, spellId)

    -- Player의 타켓인 경우만
    --if( not UnitIsUnit("playertarget", unitId ) ) then    -- 요건 두번씩 실행된다. 각 unitFrame과 targetFrame.
    --if( not UnitIsUnit(unitId, "target") and not UnitIsUnit(unitId, "mouseover") ) then
    if( not UnitIsUnit(unitId, "target") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅 툴팁 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingTooltip"] ) then
        return;
    end

    -- 스킬정보 없는 경우는 재확인
    if( not spellId ) then
        spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
        if( not spellId ) then
            return;
        end
    end

    local tooltip = _G["LJDCastingToolip"];
    tooltip.IsTarget = true;

    LJDDrawCastingSpellTooltip(tooltip, unitId, spellId);

end

-- 가장 최근 사용한 스킬 툴팁을 보여준다.(마우스오버용)
function LJDShowCastingSpellToolipMO(unitId, spellId)

    -- Player의 타켓인 경우만
    --if( not UnitIsUnit("playertarget", unitId ) ) then    -- 요건 두번씩 실행된다. 각 unitFrame과 targetFrame.
    --if( not UnitIsUnit(unitId, "target") and not UnitIsUnit(unitId, "mouseover") ) then
    if( not UnitIsUnit(unitId, "mouseover") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅 툴팁 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingTooltip"] ) then
        return;
    end

    -- 스킬정보 없는 경우는 재확인
    if( not spellId ) then
        spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
        if( not spellId ) then
            return;
        end
    end

    local tooltip = _G["LJDCastingToolipMO"];
    tooltip.IsTarget = false;
    
    LJDDrawCastingSpellTooltip(tooltip, unitId, spellId);
end


-- 툴팁을 그린다.(대상, 마우스오버 함께 사용함)
function LJDDrawCastingSpellTooltip(tooltip, unitId, spellId)

    if( tooltip ) then
        --local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellId);
        local spellLink = GetSpellLink(spellId);
        if( not spellLink ) then
            --DebugPrint("SpellLink Nil : " .. spellId );
            return;
        end
        
        tooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");  -- 혹시 옮기면 옮긴자리 유지.(ANCHOR_PRESERVE)
        tooltip:SetHyperlink(spellLink);

        -- GameTooltipTemplate.xml 파일에서 오른쪽 상단 FontString 있음을 확인함.
        -- 여기선, LJDCastingToolipTextRight1
        local textRight1 = _G[tooltip:GetName().."TextRight1"];
        if( textRight1 ) then
            --textRight1:SetText("(15 초만 보임)");
            textRight1:SetText(LJDGetClassColoredName(unitId).."  X");  -- 닫기버튼 표시 위치 위해 좀 띄움(X는 의미 없음)
            textRight1:Show();  -- 기본숨김처리 되어있음.
            tooltip:Show(); -- ReDraw
        end

        local textRight2 = _G[tooltip:GetName().."TextRight2"];
        if( textRight2 ) then
            if( tooltip.IsTarget ) then
                textRight2:SetText("|c".."ffff00ff".."대상".."|r");   -- 보라색
                --textRight2:SetText(LJDGetClassColoredName(unitId, "대상"));
            else
                textRight2:SetText("|c".."ff00ff00".."마우스오버".."|r"); -- 초록색
                --textRight2:SetText(LJDGetClassColoredName(unitId, "마우스오버"));
            end
            
            textRight2:Show();  -- 기본숨김처리 되어있음.
            tooltip:Show(); -- ReDraw
        end
        --tooltip:SetScale(0.9);

        ------------------------------------------------
        -- 마지막 스킬이 사용되고, 15초뒤 툴팁 자동숨김
        -- (1초 단위로 남은시간 표현)
        ------------------------------------------------
        if( tooltip.timerShowTooltop and not tooltip.timerShowTooltop:IsCancelled() ) then
            tooltip.timerShowTooltop:Cancel();  -- 최신스킬이 사용되었으니 시간갱신위해 중지
            tooltip.timerShowTooltop = nil;
        end
        
        -- 1초마다 실행될 calback 함수
        local function calbackPerSecond(timer)
            
            if(timer._remainingIterations > 1) then
                -- 정신사나움
                --LJDCastingToolipTextRight1:SetText(tostring( timer._remainingIterations - 1 ).." 초후 툴팁사라짐");
            else
                -- 숨김
                tooltip:Hide();
            end
        end
        
        -- [캐스팅 툴팁 자동숨기기] 설정에 따라
        if( not LJDSpellInterruptDB["AutoHideCastingTooltip"] ) then
            return;
        end

        -- 1초간격 15번 calbackPerSecond 수행
        tooltip.timerShowTooltop = C_Timer.NewTicker( 1, calbackPerSecond, 15);
    end

end

